#include <system_error>
#include "license_file.hpp"

extern "C" int xlic_find_product_license(
	xlic_license ** output,
	const char * filename,
	const char * product_name
) {
	*output = nullptr;
	try {
		const license_file license_bin(filename);
		if (const license_t * license = license_bin.find(product_name)) {
			*output = license->export_license();
			return EXIT_SUCCESS;
		}
	} catch (std::system_error & e) {
		fprintf(stderr, "Error: %s\n", e.what());
		return e.code().value();
	} catch (std::exception & e) {
		fprintf(stderr, "Error: %s\n", e.what());
	}
	return EINVAL;
}
