#ifndef __LICENSE_HPP__
#define __LICENSE_HPP__

#include <list>
#include "license_key.hpp"
#include "signature.hpp"
#include "microtime.hpp"
#include "public_key.hpp"
#include "timestamp.hpp"
#include "config.h"

struct license_t {
	std::string name;
	std::string description;
	microtime_t generated;
	timestamp_t expires;
	license_key_t key;
	signature_t signature;

	xlic_license * export_license() const;

	bool remove(const std::string & url);

	bool validate(
		const std::string & url,
		public_key_t & public_key,
		const std::string & alternative_serial_number);

	static void validate(
		const std::string & url,
		public_key_t & public_key,
		std::list<license_t> & licenses,
		const std::string & alternative_serial_number,
		const xlic_license_type type);

	bool valid(const public_key_t & public_key) const;
};

#endif
